--ݒ
scene=GetScene()
panel=GetPanel()
camera=GetCamera()
PI=3.14159265358979
camera.r = 2000.0
camera.cam_zoom_brk = 1.0
objects={}
star_count = 0

--^CXP[bł킷
timescale = {}
timescale[1] = {name="1b",   time=1.0, realtime = 1.0}
timescale[2] = {name="1",   time=60.0, realtime = 1.0}
timescale[3] = {name="1", time=3600.0, realtime = 1.0}
timescale[4] = {name="1",   time=3600.0*24.0, realtime = 1.0}
timescale[5] = {name="1", time=3600.0*24.0*30.0, realtime = 1.0}
current_ts = 1;

--P(0.0001AU = 1L)
function Create_FixedStar(star_table)
	star=FixedStar:new(star_count)
	star:SetupName(star_table.name)
	star.d = star_table.d
	table.insert(objects, star)
	star_count = star_count + 1
	print(string.format("Create...%s", star:GetPropString("name")))
	return star
end

--fB (0.0001AU = 1L) , Ƃ肠傫͂̂܂܁AO͂̂܂܁B߂ɗSĂ
function Create_Planet(orbit_table)
	planet=Planet:new()
	planet:SetupTexture(orbit_table.texture)
	planet:SetupName(orbit_table.name)
	planet.orbit_w = 2.0*PI / (orbit_table.orbit_T)
	planet.spin_w  = 360.0 / (orbit_table.spin_T)
	planet.d = orbit_table.d
	planet.r = orbit_table.r
	planet.e = orbit_table.e
	planet.timescale = timescale[current_ts].time
	table.insert(objects, planet)
	print(string.format("Create...%s", planet:GetPropString("name")))
	return planet
end

function Create_System(system_table)
	index, obj = next(system_table,nil)
	while index
	do
		if obj.type=="star" then
			star_obj = Create_FixedStar(obj.orbit)
			scene:AddChild(star_obj)
		end
		if obj.type=="planet" then
			planet_obj = Create_Planet(obj.orbit)
			scene:AddChild(planet_obj)
		end
		index, obj = next(system_table, index)
	end
end

function mod_timescale()
	scene:SetBroadcastPropDouble("time_scale", timescale[current_ts].time);
	panel:SetupTimer(timescale[current_ts].realtime)
	panel:SetupTimeScale(timescale[current_ts].name)
end

--L[{[h֐
earth_flag = 0
mercury_flag = 0
function keyboard(c)
	print(c)
	if c=="v" then
		current_ts = current_ts + 1
		if current_ts > 5 then
			current_ts = 1
		end
		mod_timescale()
	end
	if c== "e" then
		if earth_flag==0 then
			scene:AddChild(earth)
			earth_flag = 1
		else
			scene:RemoveChild(earth)
			earth_flag = 0
		end
	end
	if c== "m" then
		if mercury_flag==0 then
			scene:AddChild(mercury)
			mercury_flag = 1
		else
			scene:RemoveChild(mercury)
			mercury_flag = 0
		end
	end

end

--

function destroy()
	index, obj = next(objects,nil)
	while index
	do
		print(string.format("destruct...%s",obj:GetPropString("name")))
		obj:delete()
		index, obj = next(objects,index)
	end
end

--pl̐ݒ
panel:SetupTimer(timescale[current_ts].realtime)
panel:SetupTimeScale(timescale[current_ts].name)

earth_orbit = {orbit_T = 3600.0*24.0*365, 
	       spin_T  = 3600.0*24.0, 
	       d       = 0.4,
	       r       = 10000.0,
	       e       = 0.0,
	       name    = "n",
	       texture = "./textures/earth.bmp"}
mercury_orbit = {orbit_T = 3600.0*24.0*87.98, 
		 spin_T  = 3600.0*24.0*58.65, 
		 d       = 2440.0/1.5e4,
		 r       = 3871.0,
		 e       = 0.20561,
		 name    = "",
		 texture = "./textures/mercury.bmp"}

earth=Create_Planet(earth_orbit)
mercury=Create_Planet(mercury_orbit)



